Package org.apache.nutch.segment

# Class SegmentMerger

java.lang.Object
org.apache.hadoop.conf.Configured
org.apache.nutch.segment.SegmentMerger

All Implemented Interfaces:
  `Configurable`, `Tool`

public class SegmentMerger extends Configured implements Tool
This tool takes several segments and merges their data together. Only the latest versions of data is retained. Optionally, you can apply current URLFilters to remove prohibited URL-s.

Also, it's possible to slice the resulting segment into chunks of fixed size.

## Important Notes

### Which parts are merged?

It doesn't make sense to merge data from segments, which are at different stages of processing (e.g. one unfetched segment, one fetched but not parsed, and one fetched and parsed). Therefore, prior to merging, the tool will determine the lowest common set of input data, and only this data will be merged. This may have some unintended consequences: e.g. if majority of input segments are fetched and parsed, but one of them is unfetched, the tool will fall back to just merging fetchlists, and it will skip all other data from all segments.

### Merging fetchlists

Merging segments, which contain just fetchlists (i.e. prior to fetching) is not recommended, because this tool (unlike the `Generator` doesn't ensure that fetchlist parts for each map task are disjoint.

### Duplicate content

Merging segments removes older content whenever possible (see below). However, this is NOT the same as de-duplication, which in addition removes identical content found at different URL-s. In other words, running DeleteDuplicates is still necessary.

For some types of data (especially ParseText) it's not possible to determine which version is really older. Therefore the tool always uses segment names as timestamps, for all types of input data. Segment names are compared in forward lexicographic order (0-9a-zA-Z), and data from segments with "higher" names will prevail. It follows then that it is extremely important that segments be named in an increasing lexicographic order as their creation time increases.

### Merging and indexes

Merged segment gets a different name. Since Indexer embeds segment names in indexes, any indexes originally created for the input segments will NOT work with the merged segment. Newly created merged segment(s) need to be indexed afresh. This tool doesn't use existing indexes in any way, so if you plan to merge segments you don't have to index them prior to merging.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `SegmentMerger.ObjectInputFormat`
  Wraps inputs in an `MetaWrapper`, to permit merging different types in reduce and use additional metadata.
  `static class`
  `SegmentMerger.SegmentMergerMapper`
  `static class`
  `SegmentMerger.SegmentMergerReducer`
  NOTE: in selecting the latest version we rely exclusively on the segment name (not all segment data contain time information).
  `static class`
  `SegmentMerger.SegmentOutputFormat`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SegmentMerger()`
  `SegmentMerger(Configuration conf)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `main(String[] args)`
  `void`
  `merge(Path out, Path[] segs, boolean filter, boolean normalize, long slice)`
  `int`
  `run(String[] args)`
  Run this tool
  `void`
  `setConf(Configuration conf)`

  ### Methods inherited from class org.apache.hadoop.conf.Configured

  `getConf`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.apache.hadoop.conf.Configurable

  `getConf`

- ## Constructor Details

  - ### SegmentMerger

    public SegmentMerger()

  - ### SegmentMerger

    public SegmentMerger(Configuration conf)

- ## Method Details

  - ### setConf

    public void setConf(Configuration conf)
    Specified by:
      `setConf` in interface `Configurable`
    Overrides:
      `setConf` in class `Configured`

  - ### merge

    public void merge(Path out, Path[] segs, boolean filter, boolean normalize, long slice) throws IOException, ClassNotFoundException, InterruptedException
    Throws:
      `IOException`
      `ClassNotFoundException`
      `InterruptedException`

  - ### run

    public int run(String[] args) throws Exception
    Run this tool
    Specified by:
      `run` in interface `Tool`
    Parameters:
      `args` - input arguments for the tool, running with no argument provides args information
    Throws:
      `Exception`

  - ### main

    public static void main(String[] args) throws Exception
    Throws:
      `Exception`